#ifndef _LOMAC_MEDIATE_H_
#define _LOMAC_MEDIATE_H_

/*************************************************************************
 *
 * lomac_mediate.h
 *
 * LOMAC - Low Water-Mark Mandatory Access Control for Linux 
 * Copyright (C) 1999, 2000 NAI Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of version 2 of the GNU General Public
 * License as published by the Free Software Foundation.  This program
 * is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.  You should have received a copy of the
 * GNU General Public License along with this program; if not, write
 * to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 *
 *************************************************************************/

#include "kernel_interface.h"

int mediate_subject_subject( const char *op_s,
			     const lomac_subject_t *p_subject_one, 
			     const lomac_subject_t *p_subject_two );
int mediate_subject_path( const char *op_s, const lomac_subject_t *p_subject,
			  const char *path_s );
int mediate_subject_object( const char *op_s, const lomac_subject_t *p_subject,
			    const lomac_object_t *p_object );
int mediate_path_path( const char *op_s, const lomac_subject_t *p_subject,
		       const char *canabsname_one_s, 
		       const char *canabsname_two_s );
int mediate_subject_subject( const char *op_s, 
			     const lomac_subject_t *p_subject,
			     const lomac_subject_t *p_target );
int mediate_subject_at_level( const char *op_s, 
			      const lomac_subject_t *p_subject,
			      const level_t target_level );
int mediate_object_at_level( const char *op_s,
			     const lomac_subject_t *p_subject,
			     const lomac_object_t *p_object,
			     const level_t target_level );

#endif
