/*
    This file is part of AirSnort.

    AirSnort is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    AirSnort is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AirSnort; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>

char hexdecode[]="0123456789ABCDEF";

int eatHexByte(char *x) {
  int r;
  if (x[0]>='0' && x[0]<='9') r=(x[0]-'0')*16;
  else if (x[0]>='A' && x[0]<='F') r=(x[0]-'A'+10)*16;
  else return(-1);
  if (x[1]>='0' && x[1]<='9') r+=x[1]-'0';
  else if (x[1]>='A' && x[1]<='F') r+=x[1]-'A'+10;
  else return(-1);
  return(r);
}

int eatHexString(char *dst,char *src,int maxlen) {
  int l=0;
  int r;
  while(l<maxlen) {
    r=eatHexByte(src);
    if (r<0) return(-1);
    dst[l++]=r;
    src+=2;
    if (*src==0) return(l);
    if (*src==':') src++;
    else return(-1);
  }
  return(-1);
}

void hexdump(unsigned char *buf,int size) {
  int r,i;
  while(size) {
    r=size; if (r>16) r=16;
    for(i=0;i<r;i++) 
      printf("%2.2x ",buf[i]);
    for(i=r;i<16;i++)
      printf("   ");
    printf("  ");
    for(i=0;i<r;i++) {
      if (buf[i]>=32 && buf[i]<128)
	printf("%c",buf[i]);
      else
	printf(".");
    }
    printf("\n");
    buf+=r;
    size-=r;
  }
}
